#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include <libexif/exif-data.h>

/* ---------------------------------------------------------------------- */

static void do_file(char *filename)
{
    ExifData   *ed;
    ExifEntry  *ee;
    int tag,i;
    const char *title, *value;

    ed = exif_data_new_from_file (filename);
    if (NULL == ed) {
	fprintf(stderr,"%s: no EXIF data\n",filename);
	return;
    }

    printf("%s\n",filename);
    for (i = 0; i < EXIF_IFD_COUNT; i++) {
	printf("   %s\n", exif_ifd_get_name (i));
	for (tag = 0; tag < 0xffff; tag++) {
	    title = exif_tag_get_title(tag);
	    if (!title)
		continue;
	    ee = exif_content_get_entry (ed->ifd[i], tag);
	    if (NULL == ee)
		continue;
	    value = exif_entry_get_value(ee);
	    printf("      0x%04x %-30s %s\n", tag, title, value);
	}
    }

    printf("--\n");
    exif_data_unref (ed);
}

int main(int argc, char *argv[])
{
    int i;

    for (i = 1; i < argc; i++)
	do_file(argv[i]);
    return 0;
}
